=============================================
NetworkManager-1.56.1
Overview of changes since NetworkManager-1.56
=============================================

* Add support for GENEVE interface.
* Allow persisting the managed state across reboots from nmcli and the D-Bus API.
* Allow changing the device's administrative state in the kernel at the same
  time as a change to the managed state from nmcli and the D-Bus API.

=============================================
NetworkManager-1.56
Overview of changes since NetworkManager-1.54
=============================================

* Unify the versioning to use everywhere the scheme with the -rcX or -dev
  suffixes when appropriate. This affects, for example, the URL and filename
  of the release tarball and the version reported by nmcli and the daemon.
  As an exception, the C API will continue to use the 90+ scheme for RC versions.
* nmcli now supports viewing and managing WireGuard peers.
* Support reapplying the "sriov.vfs" property as long as
  "sriov.total-vfs" is not changed.
* Support reapplying "bond-port.vlans".
* Accept hostnames longer than 64 characters from DNS lookup.
* Make that global-dns configuration overwrites DNS searches and
  options from connections, instead of merging all together.
* Add support for a new rd.net.dhcp.client-id option in
  nm-initrd-generator.
* Add gsm device-uid setting to restrict the devices the connection applies to.
* Support configuring the HSR protocol version via the
  "hsr.protocol-version" property.
* Fix a bug that makes broadband connections auto-connect getting 
  blocked if the connection tries to reconnect when modem status is 
  "disconnecting" / "disconnected".
* Treat modem connection not having an operator code available
  as a recoverable error.
* Add support for configuring systemd-resolved's DNSSEC option
  per-connection via the "connection.dnssec" connection property.
* Support configuring the HSR interlink port via the
  "hsr.interlink" property.
* Fix some connection properties not being applied to vpn connections
  (connection.mdns, connection.llmnr, connection.dns-over-tls,
   connection.mptcp-flags, ipv6.ip6-privacy)
* Update n-acd to always compile with eBPF enabled, as support
  for eBPF is now detected at run time.
* Add new MPTCP 'laminar' endpoint type, and set it by default alongside
  the 'subflow' one.
* For private connections (the ones that specify a user in the
  "connection.permissions" property), verify that the user can access
  the 802.1X certificates and keys set in the connection.
* Introduce a libnm function that can be used by VPN plugins to check
  user permissions on certificate and keys.

=============================================
NetworkManager-1.54
Overview of changes since NetworkManager-1.52
=============================================

* Add support for configuring per-device IPv4 forwarding via the
  "ipv4.forwarding" connection property.
* Add a new "prefix-delegation" setting containing a "subnet-id"
  property that specifies the subnet to choose on the downstream
  interface when using IPv6 prefix delegation.
* Support OCI baremetal in nm-cloud-setup
* When activating a WireGuard connection to an IPv6 endpoint, now
  NetworkManager creates firewall rules to ensure that the incoming
  packets are not dropped by kernel reverse path filtering.
* Add support for configuring the loopback interface in nmtui.
* Most of the properties of ovs-bridge and ovs-port connections can
  now be reapplied at runtime without bringing the connection down.
* Add a new "sriov.preserve-on-down" property that controls whether
  NetworkManager preserves the SR-IOV parameters set on the device
  when the connection is deactivated, or whether it resets them to
  their default value.
* Introduce a new "ovs-dpdk.lsc-interrupt" property to configure the
  Link State Change (LSC) detection mode for OVS DPDK interfaces.
* The initrd-generator now can parse the NVMe Boot Firmware Table
  (NBFT) to configure networking during early boot.
* Add systemd services to provide networking in the initrd.

=============================================
NetworkManager-1.52
Overview of changes since NetworkManager-1.50
=============================================

* Store interactive history in `$XDG_CACHE_HOME/nmcli-history` instead of
  `~/.nmcli-history`
* Add new ipv4.link-local=fallback to set an IPv4 link-local address
  when no other IPv4 is set.
* Remove support for building with Autotools
* Add IPVLAN interface support
* Allow to manually configure the authentication of LTE's initial EPS Bearer.
* Add support for the "IPv6-only preferred" DHCPv4 option (RFC 8925),
  used to indicate that a host supports an IPv6-only mode and is
  willing to forgo obtaining an IPv4 address if the network provides
  IPv6 connectivity.
* Support automatically adding routes to DNS servers via the
  ipv4.routed-dns and ipv6.routed-dns properties; when enabled, each
  name server is reached only via the device that specifies it.
* Support OCI in nm-cloud-setup
* Added support for ethtool FEC mode
* Add new ipv4.shared-dhcp-range and ipv4.shared-dhcp-lease-time,
  which allows you to customize the DHCP range and lease time offered
  by DHCP server in `shared` connection method.
* DNS servers can now be specified with a URI-like syntax which supports
  DNS over TLS name servers.
* The initrd-generator understands the "rd.net.dns" option to configure
  global name servers.
* Drop support for the "dhcpcanon" DHCP client.
* global-dns configuration section now has 2 additional keys: "resolve-mode"
  and "certification-authority".
* Dnsconfd plugin can now be used for configuration of system-wide DNS
  caching resolver. If dnsconfd plugin is enabled and ipvX.routed-dns is
  set to -1 then adding routes is by default enabled.
* Add "shared" method to the IPv6 configuration options in nmtui.
* Fix a bug that prevented the activation of bond and bridge's ports in some cases
* Fix a bug that prevented the activation of OVS interfaces in some cases
* Fix MTPCP endpoint creation for IPv4 with DAD and IPv6 tentative addresses
* Fix some VPN routes not being added to the table specified in ipv4/6.routing-table.
  This fix allow to use policy routing to mitigate Tunnelvision attacks.

=============================================
NetworkManager-1.50
Overview of changes since NetworkManager-1.48
=============================================

* The support for "dhclient" has been deprecated, not built unless
  explicitely enabled, and will be removed in a future release.
  The internal DHCP client should be used instead and has been
  the default since version 1.20 (1.12 when built with meson).
* Support matching a OVS system interface by MAC address.
* Add a timeout option to connectivity checking.
* Support configuring veth interfaces in nmtui.
* When looking up the system hostname from the reverse DNS lookup of
  addresses configured on interfaces, NetworkManager now takes into
  account the content of /etc/hosts.
* Revert to using sysctl ipv6.conf.default for ip6-privacy
* Allow specifying a system OVS interface by MAC address
* ndisc: Support multiple gateways for a single network
* wifi: Support configuring channel-width in AP mode
* keyfile: Stop writing offensive terms into keyfiles
* Support reapplying the VLANs on bridge ports.
* Fix crash caused by malformed LLDP package if debug log is enabled
* Retry hostname resolution when it fails

=============================================
NetworkManager-1.48
Overview of changes since NetworkManager-1.46
=============================================

* Building with autotools is now deprecated and will be completely removed
  in the next development cycle. We recommend using meson to build
  NetworkManager -- for basic setup, see the CONTRIBUTING.md file.
  To ignore this deprecation and still build with Autotools, you can specify
  the '--disable-autotools-deprecation' argument when configuring.
* Support changing the OpenSSL ciphers for 802.1X authentication via
  connection property "802-1x.openssl-ciphers".
* The reason why a device is unmanaged is now properly set in the
  "StateReason" property of the "Device" D-Bus object. The property is
  visible in nmcli via "nmcli -f all device show $DEV".
* Deprecated 802-11-wireless and 802-11-wired property 'mac-address-blacklist'
  and introduced the 'mac-address-denylist' property.
* Properly restore in-memory connection profiles during the rollback
  of a checkpoint.
* Fix detection of 6 GHz band capability for WiFi devices
* Allow IPv6 SLAAC and static IPv6 DNS server assignment for modem broadband
  when IPv6 device address was not explicitly passed on by ModemManager
* Fix a performance issue that was leading to 100% CPU usage by NetworkManager
  if external programs were doing a big amount of routes updates.
* Patch-level development releases (i.e. 1.48.1-dev) won't be used anymore.
  From now on, all the patch releases whithin a stable branch will be normal
  releases, like 1.48.0, 1.48.1, 1.48.2, 1.48.3 and so on.
  Odd numbers in the minor version number still indicates if it's a development
  branch like 1.49 or a stable one like 1.48.

=============================================
NetworkManager-1.46
Overview of changes since NetworkManager-1.44
=============================================

* Support dynamic value "${NETWORK_SSID}" for connection.stable-id to generate
  the stable ID based on the Wi-Fi's SSID.
* Support new value "wifi.cloned-mac-address=stable-ssid" for randomizing the
  MAC address based on the Wi-Fi network.
* Change internal ABI of NMSetting types and NMSimpleConnection. The layout of
  these structs was already hidden from public headers since 1.34 and this change
  should not be noticeable.
* Honor udev property ID_NET_AUTO_LINK_LOCAL_ONLY=1 for enabling
  link local addresses on default wired connection.
* Honor udev property ID_NET_MANAGED_BY to only manage an interface
  when set to "org.freedesktop.NetworkManager".
* D-Bus methods StartFind() and StopFind() on interface
  "org.freedesktop.NetworkManager.Device.WifiP2P" now require the
  "org.freedesktop.NetworkManager.wifi.scan" Polkit permission.
* Drop build support with Python2. Python3 is now required.
* nmcli: limit number of printed addresses/routes in `nmcli` overview to 10.
* Limit number of exported IP addresses/routes on D-Bus to 100 to reduce
  performance cost. Also, D-Bus updates for addresses/routes are now rate
  limited to 3 per second.
* cloud-setup: enable more sandboxing options in systemd service file.
* nmcli: show WiFi bandwidth.
* Internal improvements and bugfixes.
* Man page now show the format and accepted values of all properties.
* Added the 'dns-change' dispatcher event.
* Show WiFi devices capability to work on the 6GHz band.
* Allow to set dhcp-client-id to none.
* Support configuring ethtool channels property to configure NIC multiqueue.
* Don't attempt to use IPv6 if it's disabled in kernel.
* Fix handling of OVS interfaces with netdev datapath and cloned MAC.
* Support for old systemd has been droped, at least systemd v200 is required.
* Support Ethtool EEE (Energy Efficient Ethernet) settings.
* Add options to prevent edns0 and trust-ad being automatically added to DNS
  configuration.
* Implement fwmark property for IP tunnels.
* Add support to HSR/PRP interfaces.
* Deprecated connection.* properties master, slave-type, autoconnect-slaves
* Allow configuring static routes also when addresses is empty.
* VPN: accept pref-src for IPv6 routes from VPN plugins.
* nmcli: show global metered state.
* Support modifying the DSCP header field for DHCP packets, and change the
  default to CS0.
* Enable IPv4 DAD (Duplicate Address Detection) by default.
* vpn: support 2FA authentication from VPN plugins.
* nmtui: allow adding a bond as bridge port.
* sriov: add support to configure the NIC's eswitch settings via Devlink.
* ndisc: fix IPv6 address lifetimes computation.
* Support the MACsec offload mode.
* Support creating generic devices via external "device-handler" dispatcher.
* Documentation improvements.
* Many internal improvements and bug fixes.

=============================================
NetworkManager-1.44
Overview of changes since NetworkManager-1.42
=============================================

* Introduce a new "link" setting that holds properties related to the
  kernel link such as "tx-queue-length", "gso-max-size",
  "gso-max-segments", "gro-max-size".
* Support sending a DHCPv6 prefix delegation hint via the
  "ipv6.dhcp-pd-hint" connection property.
* Support new bond options: "arp_missed_max", "lacp_active",
  "ns_ip6_target".
* Add new "initial-eps-bearer-configure" and "initial-eps-bearer-apn"
  properties in the GSM setting.
* Setting "connection.stable-id=default${CONNECTION}" changed behavior to
  be identical to the built-in default value when the stable-id is not set.
* Add a "[keyfile].rename" option to NetworkManager.conf to force renaming
  profiles on disk when their name changes.
* The ifcfg-rh plugin is deprecated; it will only receive bugfixes and
  no new features. A warning is emitted the log when a connection in
  ifcfg-rh format is found.
* To automatically migrate existing ifcfg-rh connections to the
  keyfile format, a new configuration option "main.migrate-ifcfg-rh"
  is provided. Migration is disabled by default, but the default value
  can be changed at build time via
  "--with-config-migrate-ifcfg-rh-default=yes".
* When configuring hostnames in non-public TLD (like "example.local"), use
  the TLD as default search domain instead of the full hostname.
* Always apply DNS options from the [global-dns] configuration section
* The NetworkManager daemon now acquires the D-Bus name only after
  populating the D-Bus tree. This can add a delay during startup but
  it is required to avoid race conditions with other services
  depending on NM.
* Add a "version-id" argument to the Update2() D-Bus call to guard
  against concurrent modifications of profiles.
* Don't use tentative IPv6 addresses to resolve the system hostname
  via DNS.
* Track the number of autoconnect retries left for each device and
  connection. Previously it was tracked only per connection and this
  lead to unexpected behaviors in case of multiconnect profiles.
* Set VLAN filtering options on bridge via netlink instead of sysfs.
* nm-cloud-setup now supports IMDSv2 on Amazon EC2.
* nmtui now supports enabling/disabling Wi-Fi and WWAN radios.
* Honor ignore-carrier=no for bond/bridge/team devices.
* Add version mismatch warning when running nmcli commands.

The following changes were backported to 1.42.x releases between 1.42.0
and 1.42.8, and are also present in NetworkManager-1.44:

- 1.42.8
* Support compiling against pppd 2.5.0.
* Support the "prio" option for bond ports.
* Better handle non-full-membership PKEY_ID with new PKEY_ID_NM
  variable in ifcfg-rh files.

- 1.42.2
* Add new "ipv[46].replace-local-rule" connection property that allows
  users to remove the autogenerated local route rule. By default,
  NetworkManager won't touch the local route rule.
* Introduce a new D-Bus property "Controller" in the ActiveConnection
  object, and deprecated the existing "Master" property.

=============================================
NetworkManager-1.42
Overview of changes since NetworkManager-1.40
=============================================

* Added support for source load balancing for Ethernet Bonds.
* Allow specifying vhost name (SNI) for a manually DNS-over-TLS server.
  Only works with systemd-resolved plugin.
* Connections can now be activated on a loopback interface.
* Added support of IPv4 ECMP routes. The ECMP routes will get merged
  automatically but the user need to configure them as single-hop routes
  specifying a valid weight.
* Add new "reapply" dispatcher event.
* Added support of VTI and VTI6 ip-tunnels along with a new property,
  "ip-tunnel.fwmark".
* VLAN can now support 802.1ad tagging instead of 802.1Q.
* Invocations of iptables now use "--wait 2" to handle races with concurrent
  calls. This fixes misbehavior with IPv4 shared mode.
* The DHCP client-id and DHCPv6 DUID are now exposed along with the lease
  information.
* Optionally suppress adding direct route to an external VPN gateway
  with the new "ipv[46].auto-route-ext-gw" property.
* Open vSwitch support gained new properties: "ovs-dpdk.n-rxq-desc",
  "ovs-dpdk.n-txq-desc", "ovs-interface.ofport-request" and
  "ovs-port.trunks".
* Added support of "other_config" for OVS bridge, port or interface. This
  property is not supported by nmcli.
* nmtui now supports editing Wi-Fi WPA-Enterprise, Ethernet with 802.1X
  authentication and MACsec connection profiles.
* nmcli now allows changing "connection.uuid" and "connection.type"
  properties in offline mode and setting the UUID when creating a
  connection.
* nmcli now accepts abbreviations for the UUID with the connection selector
  in `nmcli connection $operator uuid $uuid`.
* DHCPv6 leases are now declined when addresses fail DAD.
* Documentation improvements.
* Many internal improvements and bug fixes.

The following changes were backported to 1.40.x releases between 1.40.0
and 1.40.10 are also present in NetworkManager-1.42:

- 1.40.10

* Fix the evaluation of the autoconnect retries.
* nm-cloud-setup now preserves addresses added externally.
* Ensure that dnsmasq is stopped after changing the dns backend and
  restarting the service.
* Fix honoring an explicit DHCPv6 DUID with dhclient.
* Other various fixes.

- 1.40.8

* Fixed a bug that caused devices (MACsec in particular) to be stuck in
  UNAVAILABLE state and not transition to DISCONNECTED if the carrier was
  ready too early.
* Improved interoperability of MACsec with some Aruba switches by allowing
  CKN shorter than 64 characters.
* Fixed an assertion failure when restarting NetworkManager with MACsec
  links configured.
* Fixed a possible DHCP helper crash when handling failure to connect to
  D-Bus.
* Corrected calculation of expiration time for items configured from IPv6
  neighbor discovery messages.
* Various fixes for platforms that don't allow unaligned memory access.

- 1.40.6

* team: also set empty port configuration so teamd
  knows about the port.
* team: restore port configuration after teamd respawn.

- 1.40.4

* dhcp: revert restarting DHCP when MAC address changes,
  for example during a bond fail over.
* various documentation fixes.
* fix non-exported ABI in libnm which was wrongly present
  in the header files but unusable so far.
* ifcfg-rh: fix writing ethtool pause settings to file.
* core: set "proto static" for manual routing rules configured
  by NetworkManager.
* Various minor bugfixes.

- 1.40.2

* Ensure that resolv.conf gets updated when the configuration changes.
* Fix setting as bond primary an interface that doesn't exist yet when the
  bond is activated.
* The number of autoconnect retries is now accounted independently for each
  device when there are profiles with multi-connect=multiple.
* Don't print duplicate entries in the output of "NetworkManager
  --print-config"
* Fix the ifcfg-rh plugin to properly read infiniband P-Key connection
  profiles without an explicit interface name.
* Allow the removal of a bond port connection profile from the bond via
  nmcli.
* Fix race condition during the activation of veth profiles when the peer
  already exists.
* Decline the DHCPv6 lease if all addresses fail IPv6 duplicate address
  detection (DAD).
* Wait that devices get carrier before trying to resolve the system hostname
  on them via DNS.
* Fix race condition during the initial activation of OVS interfaces.
* Profiles generated by nm-initrd-generator now have lower than default
  priority.
* Fix error when adding many SR-IOV virtual functions (VFs).

=============================================
NetworkManager-1.40
Overview of changes since NetworkManager-1.38
=============================================

* Drop unused, internal systemd DHCPv4 client. This is long
  replaced by nettools' n-dhcp4 implementation.
* The nmcli command now supports --offline argument with "add" and
  "modify" commands, allowing operation on keyfile-formatted connection
  profiles without the service running (e.g. during system provisioning).
* The device state file /run/NetworkManager/devices/$ifindex now has
  new sections [dhcp4] and [dhcp6] containing the DHCP options for the
  current lease.
* Add multipath TCP (MPTCP) support. NetworkManager can now configure IP addresses
  as MPTCP endpoints. This is configurable via the "connection.mptcp-flags"
  property. The default setting is such that MPTCP handling is automatically
  enabled if the kernel sysctl "/proc/sys/net/mptcp/enabled" indicates so.
  NetworkManager does not enable the MPTCP sysctl or adjust the limits (ip mptcp limits).
  The administrator or the distribution is supposed to configure the desired system
  settings.
  Note that strict reverse path filtering (rp_filter) breaks many MPTCP use cases.
  With MPTCP handling enabled, NetworkManager will relax a strict (1) rp_filter
  to loose (2). Otherwise rp_filter is untouched by NetworkManager.
* NetworkManager expanded log messages for invalid DHCP options.
* Fix the requirement of hardware address for DHCPv6, by dropping it.
* Increase the PMK lifetime for Wi-Fi connections using WPA-EAP.
* "nmcli networking off" now waits for deactivations to complete.
* Improve the appearance of nm-settings-nmcli man page by preserving
  paragraphs.
* Support enabling ipv4ll alongside DHCPv4 and static addressing.
* Support configuring "ipv6.mtu".
* The "ipv6.addr-gen-mode" property can now have a default value
  specified via global connections defaults in NetworkManager.conf.
* Honor "nm.debug" kernel command line to enable debug logging of
  NetworkManager.
* NetworkManager reads the kernel command line "/proc/cmdline" for several
  purposes, including "nm.debug" for enabling debugging and the
  "match.kernel-command-line" setting in the profile. NetworkManager now
  first looks now for "/run/NetworkManager/proc-cmdline", which allows one to
  overwrite the command line.
* Improve the reapply of non-bridge properties.
* Honor adding a Bluetooth NAP connection with all available methods.
* Improve carrier detection.
* During the build, stop relying on intltool for i18n and use gettext only.
* Undeprecate nm_remote_connection_get_secrets() in libnm.
* NetworkManager now will restart DHCP if the MAC changes on a device.
* Several internal improvements.

The following changes were backported to 1.38.x releases between 1.38.0
and 1.38.4 are also present in NetworkManager-1.40:

- 1.38.4

* Fix DAD for DHCPv6 addresses.
* Wi-Fi: improvements for OWE networks.
* Support EC private keys.
* Fix nmcli tab completion support for embedded quote characters.
* Fix reapply for lldp/mdns/llmnr/dns-over-tls settings.
* Various bugfixes.

- 1.38.2

* Fix race condition with pppd that caused failures when activating
  PPPoE connections.
* Unbreak DHCPv6 over PPP.
* Don't ignore IPv6 DNS servers received from PPP.
* Fix crash while checking WEP capability of Wi-Fi interfaces.
* Ensure DHCP is restarted every time the link goes up.
* Fix struct alignment issues seen on some architectures.
* Various other bugfixes and improvements.

=============================================
NetworkManager-1.38
Overview of changes since NetworkManager-1.36
=============================================

* Add support for route type "throw".
* Fix bug setting priority for IP addresses.
* Static IPv6 addresses from "ipv6.addresses" are now preferred over
  addresses from DHCPv6, which are preferred over addresses from autoconf.
  This affects IPv6 source address selection, if the rules from
  RFC 6724, section 5 don't give a exhaustive match.
* Static IPv6 addresses from "ipv6.addresses" are now interpreted with
  first address being preferred. Their order got inverted. This is now
  consistent with IPv4.
* Wi-Fi hotspots will use a (stable) random channel number unless one is
  chosen manually.
* Don't use unsupported SAE/WPA3 mode for AP mode.
* NetworkManager will no longer advertise frequencies as supported when
  they're disallowed in configured regulatory domain.
* Attempt to connect to WEP-encrypted Wi-Fi network will now fail
  gracefully with a recent version of wpa_supplicant when built
  without WEP support. As long as wpa_supplicant supports WEP,
  NetworkManager will continue to work.
* Disable WPA3 transition mode for wifi.key-mgmt=wpa-psk if the NIC
  does not support PMF. This is known to cause problems in some setups. It
  is still possible to explicitly configure wifi.key-mgmt=sae for WPA3.
* Add new dummy crypto backend "null" that does nothing. NetworkManager
  uses the crypto library when handling certificates for 802.1x profiles.
* Veth devices with name "eth*" are now managed by default via the
  udev rule. This is to support managing the network in LXD containers.
* The hostname received from DHCP is now shortened to the first dot
  (or to 64 characters, whatever comes first) if it's too long.
* As the insecure WEP encryption for Wi-Fi network is phased out,
  nmcli now discourages its use when activating or modifying a
  profile.
* Fix connectivity checks in case the check endpoint address resolves to
  multiple addresses.
* Workaround libcurl blocking NetworkManager while resolving DNS names.
* nmcli: indicate missing Wi-Fi hardware when showing rfkill setting.
* nmcli: add connection migrate command to move a profile to a specified
  settings plugin. This allows one to convert profiles in the deprecated ifcfg-rh
  format to keyfile.
* Set "src" attribute for routes from DHCPv4 to the leased address. This
  helps with source address selection.
* Updated translations.
* Various bugfixes and internal improvements.

The following changes were backported to 1.36.x releases between 1.36.0
and 1.36.4 are also present in NetworkManager-1.38:

- 1.36.4
* The internal DHCPv4 client now discards NAKs packets coming
  from servers different from the one that sent the offer.
* Fixed a couple of regressions in PPPoE support since 1.36.0.
* Fix potential libnm crash when the client object initialization gets
  canceled.
* Other various fixes and improvements.

- 1.36.2
* When the list of plugins is not specified via "main.plugins" in
  NetworkManager.conf and no build-time default is set with
  "--with-config-plugins-default" configure argument, now all known
  plugins found in the plugin directory are loaded (and the built-in
  "keyfile" plugin is preferred over others).
* Preserve external ports during checkpoint rollback
* Fix removal of ovsdb entry when an OVS interface goes away
* Fix DNS configuration for WWAN connections

=============================================
NetworkManager-1.36
Overview of changes since NetworkManager-1.34
=============================================

* The handling of Layer 3 configurations has been substantially reworked.
  While this is mostly internal change, it results in more robust
  behavior when addressing information from multiple sources (DHCP,
  manually configured, VPN) need to be applied simultaneously.
  Overall performance and memory use have also slightly improved.
* Manually configured addresses can no longer expire even if the same
  addresses are also obtained dynamically.
* Code for systemd-based DHCP and DHCPv6 clients has been updated from
  upstream.
* NTP servers obtained via DHCPv6 are now exposed on the DBus API, visible
  in nmcli and available for use by dispatcher scripts.
* 5G NR (New Radio) modems are now supported.
* The "rd.znet_ifnames" kernel command line option is now honored on
  network bootups on an IBM s390 platform.
* Wi-Fi P2P support does now work with the IWD backend, in addition to
  wpa_supplicant backend.
* Support for special route types have been added: "prohibit", "blackhole"
  and "unreachable".
* Routes managed by routing daemons are now ignored. This is done to
  address a performance bottleneck on specialized routers.
* Handling of IP addressing and routing information is now slightly
  more efficient and uses less memory. This is apparent on systems with
  large amount of IP configuration information.
* It is now possible to start NetworkManager without root user privileges.
  This is experimental doesn't necessarily result in a working daemon.
  NetworkManager service already drops many of capabilities available
  to the root user.
* WPA3 Wi-FI network security have been improved by enabling new H2E (hash
  to element) method for generating SAE password element.
* It is now possible to select the default Wi-Fi backend (wpa_supplicant or
  IWD) at build-time.
* Replies from broken DHCP servers that send duplicate address or mask
  options are now handled gracefully.
* Bridge support has gained the possibility of turning off MAC ageing.
* "configure-and-quit" mode and nm-iface-helper have been removed.
* A number of bugs that could cause NetworkManager to crash in rare
  conditions have been fixed.

=============================================
NetworkManager-1.34
Overview of changes since NetworkManager-1.32
=============================================

* initrd: wait for both IPv4 and IPv6 with "ip=dhcp,dhcp6".
* core: better handle sd-resolved errors when resolving hostnames.
* nmcli: fix import WireGuard profile with DNS domain and address
  family disabled.
* ndisc: send router solicitations before expiry.
* policy: send earlier the ip configs to the DNS manager.
* core: support linking with LLD 13.
* wireguard: importing wg-quick configuration files with nmcli
  no longer sets a negative, exclusive "dns-priority". This plays
  better with common split DNS setups that use systemd-resolved.
  Adjust the "dns-priority" to your liking after import yourself.
* NetworkManager no longer listens for netlink events for traffic
  control objects (qdiscs and filters).
* core: add internal nm-priv-helper service for separating privileges
  and have a way to drop capabilities from NetworkManager daemon.
* bond: add support for setting queue-id of bond port.
* dns: support configuring DNS over TLS (DoT) with systemd-resolved.
* nmtui: add support for WireGuard profiles.
* nmcli: add aliases `nmcli device up|down` beside connect|disconnect.
* conscious language: Deprecate 'Device.Slaves' D-Bus property in favor of new
  'Device.Ports' property. Depracate 'nm_device_*_get_slaves()' in favor of
  'nm_device_get_ports()' in libnm.
* nmcli: invoking nmcli command without arguments will now show 'default'
  instead of null address in route4 or route6 section.

The following changes were backported to 1.32.x releases between 1.32.0
and 1.32.12 are also present in NetworkManager-1.34:

- 1.32.12:
* Fix wrong order of addresses when restarting NetworkManager.
* Preserve the IPv6 ff00::/8 route added by kernel in the local table,
  necessary for multicast communication.
* Fix emitting the signal for changed metered status of devices.
* Fix applying the ethtool autonegotiation and speed settings.
* initrd: fix crash parsing plain '=' without key.
* cloud-setup: use suppress_prefixlength rule to honor
  non-default-routes in the main table.

- 1.32.10:
* core: fix the order of IPv6 addresses changing on service restart.
* initrd: add command line option to configure link autonegotiation
  and speed.
* ifcfg-rh: fix crash when parsing invalid DNS address.
* ifcfg-rh: extend ifup/ifdown scripts to work with connection profile
  names.
* udev: also react to "move" (and "change") udev actions in our rules.

- 1.32.8:
* firewalld: configure zones on "Reloaded" signal.
* core: fix wrong MTU for bridge interfaces.
* cloud-setup: fix gateway address for Aliyun cloud.

- 1.32.6:
* core: fix adding stale local routes when address changes.
* initrd: tag generated profiles with origin in user data.
* core: introduce "allowed-connections" option to disallow
  profiles on a device. This allows one to filter out profiles
  that originate from initrd.
* core: introduce "keep-configuration" device option to forcefully
  activate a profile on start.
* dhcp: handle filename/bootfile_name DHCP option and write it to
  device state file for initrd/kickstart.
* initrd: add "ib.pkey=" command line option

- 1.32.4:
* core: remove stale entries from "seen-bssids" and "timestamp"
  files in "/var/lib/NetworkManager".
* bond: support the peer_notif_delay option.
* core: add ipv[46].required-timeout option to wait for IP
  configuration while activating.
* core: send ARP announcements when there is carrier.
* core: start DHCPv6 when a prefix delegation is needed for shared
  mode.
* firewall: fix nftables backend to create "ip" table for
  IPv4 only.
* initrd: set required-timeout of 20 seconds for default IPv4 configuration
  to opportunistically wait for IPv4.
* ifcfg: log warning about invalid keys in ifcfg files.
* ifcfg: reject non-UTF-8 from ifcfg files.
* nmcli: show DNS SEARCH field in device information.
* cloud-setup: add support for Aliyun cloud.

- 1.32.2:
* hostname: prefer IPv4 addresses for reverse DNS lookup.
* dhcp: ignore unauthenticated FORCERENEW messages with
  internal, systemd-based DHCPv4 plugin (CVE-2020-13529).
  This plugin is not used, unless the undocumented dhcp=systemd
  option was set.
* cloud-setup: preserve IP addresses, routes and rules from
  currently active connection profile.
* Various bugfixes and performance improvements.

=============================================
NetworkManager-1.32
Overview of changes since NetworkManager-1.30
=============================================

* Add an 'accept-all-mac-addresses' property to the ethernet setting
  to accept frames with any MAC address (also known as promiscuous
  mode).
* nmcli: fix setting property aliases to empty value to reset the
  default value.
* BEHAVIOR CHANGE: Enforce valid lower case UUID format for the "connection.uuid"
  by normalizing the value. This changes the UUID of existing profiles with an
  invalid or non-normalized value. Also normalize "connection.secondaries" to only
  contain valid and distinct UUIDs. Profiles that set "connection.master" or the
  "parent" properties to a non-normalized UUID need adjustment. Using such
  non-normalized UUIDs should be rare and affect few users.
* API CHANGE: D-Bus: remove long deprecated "PropertiesChanged" signal from D-Bus
  API. They are replaced by standard "PropertiesChanged" signal on the
  "org.freedesktop.DBus.Properties" interface. It is not expected that anybody
  is still using this API.
* Now NetworkManager uses systemd-resolved API to lookup the system
  hostname via reverse DNS. If systemd-resolved is not available, a
  'nm-daemon-helper' binary is spawned to perform the lookup using
  the 'dns' NSS module.
* dhcp: honor "ID_NET_DHCP_BROADCAST" udev attribute to set the broadcast flag.
  This allows one to configure devices in udev for which DHCPOFFER messages are to be
  broadcast.
* firewall: add nftables firewall backend for configuring IPv4 NAT with shared
  mode. Now two backends are supported, "iptables" and "nftables". The default
  gets detected based on whether /usr/sbin/nft or /usr/sbin/iptables is installed,
  with nftables preferred.
  Please note that SELinux might prevent NetworkManager from communicating with nft.
* ethtool: add support for pause settings.
* Support "prohibit"/"blackhole"/"unreachable" type routing rules.
* Support uidrange attribute for policy routing rules.
* Now NetworkManager preserves by default the existing traffic control
  configuration (qdiscs and filters) when activating a connection.
* wifi/iwd: mirror NetworkManager connection profiles to iwd config files.
* API CHANGE: vala: fix wrongly generated vapi for WireGuard API.
* wifi: fix parsing of Microsoft Network Cost information element for
  detecting metered networks.
* dhcp: support option 249 (Microsoft Classless Static Route) with nettools
  internal DHCP plugin.
* initrd: support the "rd.net.dhcp.retry" kernel argument for controlling retry
  and timeout to get a DHCP lease.
* API CHANGE: hide definitions of structs for NMSetting and NMSimpleConnection from
  public headers.
* Major restructuring of the source code.
* Many bugfixes and minor improvements.

=============================================
NetworkManager-1.30
Overview of changes since NetworkManager-1.28
=============================================

* Increase timeout of NetworkManager-wait-online.service to 60 seconds.
* Add "ipv4.dhcp-client-id=ipv6-duid" option for RFC4361.
* The dhcpcd plugin now requires a minimum version of dhcpcd-9.3.3 with
  the --noconfigure option. Using an older version will cause dhcpcd to
  exit with a status code of 1.
* Support building against musl libc.
* Support new ethtool offload features.
* Add support for WPA3 Enterprise Suite-B 192 bit mode.
* Add support for handling Veth devices.
* New hostname settings for controlling configuring the hostname from
  reverse DNS lookup and from DHCP.
* OVS: support configuring external-ids.
* libnm: nm_setting_bond_add_option() no longer validates the
  option that is set. Instead, use nm_connection_verify() to validate
  the profile.
* libnm: add support for reading/writing keyfile format. This required to
  relicense previously GPL-2.0+ code as LGPL-2.1+ with the agreement of the
  copyright holders.
* initrd: support for rd.net.timeout.carrier option.
* initrd: support new ip method "link6" for IPv6 link-local only.
* ci: use ci-templates for containers on gitlab-ci.
* ci: test build against Alpine Linux on gitlab-ci.
* build: new configure option to set path to "polkit-agent-helper-1".
* Many bugfixes, improvements and translation updates.

=============================================
NetworkManager-1.28
Overview of changes since NetworkManager-1.26
=============================================

* Introduce a new "rc-manager=auto" setting and make it the default,
  unless a different default is chosen at compile time.  This mode
  tries to detect "systemd-resolved", "resolvconf", and "netconfig"
  and chooses the mode that seems most suitable depending on build
  setting and runtime detection.  "resolvconf" and "netconfig" are
  only considered iff NetworkManager was built with the respective
  options enabled.
* The long deprecated D-Bus property "Ip4Address" on
  "org.freedesktop.NetworkManager.Device" interface is now defunct and
  always returns zero.
* Introduce a ipv4.dhcp-reject-servers connection property that
  specifies a list of DHCP server-ids from which offers should be
  rejected.
* Add a ipv4.dhcp-vendor-class-identifier connection property to send
  a custom value for the Vendor Class Identifier DHCP option.
* Support obtaining the system hostname through the FQDN DHCPv6
  option.
* dbus: don't require policykit permission for GetAppliedConnection of
  a device.
* When supported by kernel, use netlink to configure bridge settings
  instead of writing to sysfs.
* Deprecate the "active_slave" bond option which now has the same effect
  as setting the "primary" option.
* The initrd generator now also accepts MAC addresses to indicate
  interfaces.
* Add a new provider for nm-cloud-setup to support automatic network
  configuration on Azure.
* The initrd generator now supports creating Infiniband connections.
* Fix running DHCPv6-PD over PPPoE.
* Fix building NetworkManager with LTO (Link Time Optimization).
* Fix failure activating Wi-Fi P2P connections.
* Reformat code using spaces instead of tabs. Also, the entire C
  source code is now formatted with "clang-format" (version 11.0).
* Change the behavior of nm-initrd-generator so that the 'ip=off|none' kernel
  cmdline argument actually generates a connection which disables both
  ipv4 and ipv6. Previously the generated connection would disable ipv4
  but ipv6 would be set to the 'auto' method.
* Fix systemd-resolved DNS plugin to configure DefaultRoute option and to
  only configure wildcard DNS search domain with exclusive DNS priority.

=============================================
NetworkManager-1.26
Overview of changes since NetworkManager-1.24
=============================================

* Add a new build option 'firewalld-zone'; when enabled,
  NetworkManager installs a firewalld zone for connection sharing and
  puts interfaces using IPv4 or IPv6 shared mode in this zone during
  activation. The option is enabled by default.
  Note that NetworkManager still calls to iptables to enable
  masquerading and open needed ports for DHCP and DNS. The new option
  is useful on systems using firewalld with the nftables backend,
  where the iptables rules would not be sufficient.
* Extend the syntax for 'match' setting properties with '|', '&', '!'
  and '\\'.
* Add MUD URL property for connection profiles (RFC 8520) and set it
  for DHCP and DHCPv6 requests.
* Expose raw LLDP message on D-Bus and the MUD usage description URL.
* ifcfg-rh: handle "802-1x.{,phase2-}ca-path". Otherwise setting this
  property silently fails and a profile might accidentally not perform
  any authentication (CVE-2020-10754).
* ifcfg-rh: handle 802-1x.pin properties.
* ethernet: reset original autonegotiation/speed/duplex settings when
  deactivating device.
* Support ethtool coalesce and ring options.
* Allow team connections to work without D-Bus (e.g. in the initrd).
* Wi-Fi profiles now also autoconnect if all previous activation attempts
  failed. This means, an initial failure to autoconnect to the network will
  no longer block the automatism. A side effect is that existing Wi-Fi profiles
  which previously were blocked may now start to autoconnect.
* NetworkManager now supports "local" type routes beside "unicast".
* Introduce new manual pages nm-settings-dbus and nm-settings-nmcli.
* Mark externally managed devices and profiles on D-Bus.
* Highlight externally managed devices in nmcli.
* Add support for a number of bridge options.
* Add match for device path, driver and kernel command line for connection
  profiles.
* Fix support for OVS patch interfaces.
* Support more tc qdiscs: tbf and sfq.
* Add new provider in nm-cloud-setup for Google Cloud Platform which
  automatically detects and configures the host to receive traffic
  from internal load balancers.

=============================================
NetworkManager-1.24
Overview of changes since NetworkManager-1.22
=============================================

* Add support for virtual routing and forwarding (VRF) interfaces.
* Add support for Opportunistic Wireless Encryption mode (OWE) for Wi-Fi networks.
* Add support for 31-bit prefixes on IPv4 point-to-point links according to
  RFC 3021.
* Drop dependencies for libpolkit-agent-1 and libpolkit-gobject-1.
* nmcli:
  - support setting removal via new command
    `nmcli connection modify $CON_NAME remove $setting`.
  - support backslash escape sequences for "vpn.data", "vpn.secrets",
    "bond.options", and "ethernet.s390-options".
* bridge: support new options "bridge.multicast-querier", "bridge.multicast-query-use-ifaddr",
  "bridge.multicast-router", "bridge.vlan-stats-enabled", "bridge.vlan-protocol",
  "bridge.group-address".
* IPv6 SLAAC: add support for "ipv6.ra-timeout" setting
* IPv6 DHCP: add support for "ipv6.dhcp-timeout" setting
* WWAN: NetworkManager now detects if a PIN-protected SIM card has been
  externally unlocked and automatically tries to activate a suitable
  connection on the modem.
* OVS:
  - add support for changing MTU of OVS interfaces.
  - remove length limitation for OVS Bridge, Patches and Interfaces
    (only Patch types) names.
* VPN: accept empty values for VPN data items and secrets.
* All nm-devices now expose the 'HwAddress' property via D-Bus.
* Slave devices now do not get created/activated if master is missing.
* Fixed multiple issues in the internal "nettools" DHCP client.
* Export NM_CAPABILITY_OVS capability on D-Bus and in libnm to
  indicate that the OVS plugin is loaded.
* Fixes for importing WireGuard profiles in nmcli and better handle
  configurations that enable ip4-auto-default-route with an explicit
  gateway.
* Various bug fixes and improvements.

=============================================
NetworkManager-1.22
Overview of changes since NetworkManager-1.20
=============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Drop support for BlueZ 4. BlueZ 5 was released in 2012 and should
  nowadays be available everywhere.
* DHCP: switch "internal" DHCPv4 plugin from code based on systemd to use nettools'
  n-dhcp4 library.
* Add support for "scope" attribute for IPv4 routes.
* Add support for specifying IAID and FQDN flags for DHCP request.
* Add a '802-1x.optional' property to consider the wired 802.1X authentication as
  optional.
* Use the Network Cost Wi-Fi information element to determine metered
  device state.
* Support main.auth-polkit=root-only setting to disable PolicyKit use and
  restrict authorization to root user.
* core: declare "startup complete" when device reaches "connected"
  state, even if IP addressing methods did not yet fully complete.
  This changes behavior for unblocking "NetworkManager-wait-online.service",
  and "network-online.target" earlier. If this causes issues in your
  setup, you may need to configure "ipv4.may-fail=no" or "ipv6.may-fail=no",
  which delays reaching "connected" state for the address family accordingly.
* libnm: hide NMObject and NMClient typedefs from header files. This prevents
  the user from subclassing these types and is an ABI change (in the unlikely
  case that a user was subclassing the types, which is no longer supported).
* libnm: retire deprecated WiMAX API NMDeviceWimax and NMWimaxNsp.
  WiMAX support was removed from NetworkManager in version 1.2 (2016) and no such
  type instances would have been created by NMClient for a while now.
* Deprecate synchronous API for D-Bus calls in libnm. We don't remove libnm API so
  you are free to continue using it. But tells you that using it might be a bad idea.
* libnm: heavily internal rework NMClient. This slims down libnm and makes the
  implementation more efficient. NMClient should work now well with a separate
  GMainContext.
* Add `nmcli general reload` subcommand to reload NetworkManager configuration
  and DNS settings.
* nm-cloud-setup: add new tool for automatically configuring NetworkManager
  in cloud. This is still experimental and currently only EC2 and IPv4 is
  supported.
* Add new NetworkManager logo to "contrib/art/logo".
* Various bug fixes and improvements.

=============================================
NetworkManager-1.20
Overview of changes since NetworkManager-1.18
=============================================

This is a new stable release of NetworkManager.  Notable changes include:

* The libnm-glib library, deprecated in favor of libnm since NetworkManager 1.0,
  and disabled by default since NetworkManager 1.12, has now been removed.
* The DHCP client now defaults to "internal". The default can be overridden
  at build time by using the --with-config-dhcp-default option of the
  configure script or at run time by setting the main.dhcp option in the
  configuration file.
* Added support for configuring fq_codel line discipline and mirred action.
* Added a possibility for distributions to ship dispatcher scripts in /usr/lib.
* Drop deprecated setting "main.monitor-connection-files" in NetworkManager.conf.
  This setting now has no more effect and was disabled by default for a long time.
  Instead, after changes, load files explicitly with `nmcli connection load` or
  `nmcli connection reload`.
* Rework parsing team JSON config in libnm and stricter validate settings.
  With this, NetworkManager rejects settings that it considers invalid while
  still allowing setting arbitrary JSON config directly.
* Drop ibft settings plugin. This functionality is now covered by using
  nm-initrd-generator from initrd to pre-generate in-memory profiles.
* Support "suppress_prefixlength" attribute for policy routing rules.
  This is what wg-quick uses for the "Improved Rule-based Routing" solution,
  and the user can now manually configure such policy routing rules.
* Support "wireguard.ip4-auto-default-route" and "wireguard.ip6-auto-default-route".
  This automatically implements the "Improved Rule-based Routing" of wg-quick
  to help avoiding routing loops when setting the default-route on the WireGuard
  interface. Note that this is now enabled by default, so there is a change in behavior
  if your WireGuard connection profiles from before had a default-route (/0)
  in allowed-ips.
* Rework implementation of settings plugins and how profiles are presisted
  to disk. This is a large internal refactoring of the settings plugins that
  allows one to migrate a connection profile between plugins.
* In-memory profiles are now only handled by keyfile plugin and will also be
  persisted to /run directory. This allows one to restart NetworkManager without
  loosing these profiles and it provides a file-system based API for creating
  in-memory profiles.
* Keyfile plugin now supports a read-only directory of profiles under directory
  "/usr/lib/NetworkManager/system-connections". Such profiles still can be modified
  and deleted via D-Bus, which results in writing profiles to /etc or /run that
  shadow the read-only files.
* Add new D-Bus method AddConnection2() that allows one to block autoconnect of
  the profile at the moment when creating the profile. Also add support for
  this API to libnm.
* Add flag "no-reapply" to Update2() D-Bus method. Normally, when a connection
  profile gets modified, this only changes the profile itself. When the profile
  is currently activated on a device, then the device's configuration does not update
  before the profile is fully re-activated or Reapply on the device is called. There
  is an exception to this: the "connection.zone" and the "connection.metered"
  properties take effect immediately. The "no-reapply" flag allows suppressing to
  reapply any properties, so that no changes take effect automatically. The purpose
  is to really only modify the profile itself without changes to the runtime configuration
  of the device.
* Add "ipv6.method=disabled" to disable IPv6 on a device, like also possible for
  IPv4. Until now, the users could only set "ipv6.method=ignore" which means the
  users are free to set IPv6 related sysctl values themselves.
* Added support for Wi-Fi Mesh network.

The following changes were backported to 1.18.x releases between 1.18.0
and 1.18.2 are also present in NetworkManager-1.18:

- 1.18.2:
* Add compatibility with out-of-tree WireGuard module on 5.2 kernels
* Fix parsing of BOOTIF= variables in initrd.
* Accept numeric IPv4 prefix in place of a mask when parsing a command line
  in initrd.
* Don't check connectivity of unconfigured devices.
* Fix PKCS#12 handling in the ifcfg-rh plugin.
* Avoid waiting for udev to see software devices created by NetworkManager.
* Don't attempt to stop management daemon for Team devices created
  externally to NetworkManager.
* Use FQDN for persistent hostname on Slackware.
* Restore IPv6 configuration of a device when its link goes back up.
* Fix management status of software devices on system suspend.
* Make nmcli not print certificate blobs if --show-secrets is not used.
* Fix MTU reapply.

=============================================
NetworkManager-1.18
Overview of changes since NetworkManager-1.16
=============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Add support for policy routing rules.
* Add support for VLAN filtering for Linux bridge.
* Support ieee-802-1 and ieee-802-3 LLDP TLVs.
* Allow large MTU sizes for infiniband/IPoIB connection profiles.
* Improve nmcli's handling of list options for connection properties.

=============================================
NetworkManager-1.16
Overview of changes since NetworkManager-1.14
=============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Check connectivity per address family.
* Support "main.systemd-resolved" to let NetworkManager configure DNS settings
  in systemd-resolved without making it the main DNS plugin of NetworkManager.
* Write "/var/run/NetworkManager/no-stub-resolv.conf" with original nameservers.
  That is useful with caching DNS plugins like "systemd-resolved" or "dnsmasq" where
  "/var/run/NetworkManager/resolv.conf" refers to localhost.
* Change default "ipv4.dhcp-client-id" setting for the internal DHCP plugin from
  "duid" to "mac". This is a change in behavior on upgrade when using the internal
  DHCP plugin (unless the default is overwritten in "NetworkManager.conf" or specified
  per connection profile).
* Improve handling of DHCP router options with internal DHCP plugin. For one, accept
  multiple routers and add a default-route to each. On D-Bus expose the original DNS
  and NTP servers without cleaning up local nameservers.
* Allow binding a connections lifetime to the DBus client that activated it.
* Add support for establishing Wi-Fi Direct connections (Wi-Fi P2P).
* Add support for WireGuard VPN tunnels to NetworkManager. D-Bus API and libnm
  support all options. nmcli supports creating and managing WireGuard profiles,
  with the exception of configuring and showing peers.
* Add initrd generator to be used by dracut and use it as new way of handling
  iBFT.
* Deprecated "plugins.monitor-connection-files" setting in NetworkManager.conf.
  This option will have no effect in future versions.
* Add AP and Ad-hoc support for iwd Wi-Fi backend.
* Warn about invalid settings in "NetworkManager.conf".
* Support announcing "ANDROID_METERED" DHCP option for shared mode.
* Support SAE authentication as used for 802.11s Meshing and WPA3-Personal.
* NetworkManager is no longer installed as D-Bus activatable service.
* Mark docker bridges as unmanaged via udev rule.
* Add new PolicyKit permission "org.freedesktop.NetworkManager.wifi.scan" for controlling
  Wi-Fi scanning.

The following changes were backported to 1.14.x releases between 1.14.0
and 1.14.6 are also present in NetworkManager-1.14:

- 1.14.6:
* Fix memory corruption in internal DHCPv6 client (CVE-2018-15688).
* No longer limit number of search entries in resolv.conf to 6.
* Support restricting NetworkManager.conf device configuration based on used DHCP
  plugin.
* Add "${MAC}" specifier for connection.stable-id. This uses the current MAC
  address for seeding the stable generation of MAC address, DHCP client-id
  or IPv6 stable-privacy interface identifier.
* Support special value "duid" for "ipv4.dhcp-client-id". This generates an
  RFC4361-compliant client-id like the internal DHCP client used to do by default.
  Previously, there was no explicit name for such a client-id and it was not
  usable with dhclient DHCP plugin. This also generates the same client-id as
  systemd-networkd does by default.
* Support and use a new kind of secret-key in "/var/lib/NetworkManager/secret_key".
  The secret-key represents the identity of the machine that is used for various
  purposes like generating IPv6 stable privacy addresses. It is now combined
  with "/etc/machine-id" so that changing only the machine-id results in new identifiers.
  That matters for example when cloning a virtual machine. Previously, the user
  hard to prune NetworkManager's secret-key to get a new identity, now regenerating
  machine-id suffices. Secret-keys generated by earlier versions of NetworkManager are
  not affected and keep their previous behavior.
* Fix the DHCP client-ids based on the MAC address of IPoIB/infiniband devices.
* Fix restoring IP configuration after interface went down.
* No longer let NetworkManager touch rp_filter setting. The rp_filter sysctl must now
  be set outside of NetworkManager according to the admin's preference. Note that a strict
  rp_filter may break valid use-cases and interacts badly with connectivity checking.
* Various bug fixes and improvements.

- 1.14.4:
* Fix a crash in nmcli when a device is removed while being disconnected.
* Fix a crash in ifupdown (Debian) configuration plugin.
* Fix a daemon crash when a generated connection doesn't validate.
* Fix a memory leak in dhclient DHCP plugin.
* Fix line editing in nmcli password prompts.
* Fix a RPATH in bluetooth and wwan plugin when built with Meson (otherwise
  they wouldn't find libnm-wwan.so).

- 1.14.2:
* Fix a bug that could cause NetworkManager to crash after checking
  connectivity status.
* Correctly apply a default (-1) metric from DHCP.
* Multiple fixes for IWD Wi-Fi backend.
* Multiple fixes for builds with Meson build system.
* Fix a crash with OLPC XO-1 mesh Wi-Fi.
* Fix handling "serial.parity" and "serial.send-delay" properties in nmcli.
* Improve auto-selecting device when activating a connection profile
  and don't auto-select unmanaged devices when activating multi-connect
  profile.
* Avoid expiring the lifetime of IPv6 addresses from router advertisements.

=============================================
NetworkManager-1.14
Overview of changes since NetworkManager-1.12
=============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Added support for IEEE 802.15.4 and 6LowPAN devices.
* Support activating profile multiple times via connection.multi-connect
  setting.
* Add match setting to restrict a profile to devices based on
  a list of interface names with globbing supported.
* Fix PrimaryConnection for VPN with default-route.
* Add support for ethtool offload features.
* Add support for configuring llmnr.
* Deprecate endian-dependent D-Bus API and add new API that can be
  used instead (rh#1153559).
* Add support for ip6gre/ip6gretap IP tunnels.
* Add support for detecting WireGuard interfaces (WireGuard VPN cannot
  be controlled via NetworkManager).
* Add support for configuring SR-IOV devices.
* Improve error reporting of activation when no device is available.
* Support reapplying changes of the route metric.
* Support EAP profiles with iwd Wi-Fi backend and support iwd API 0.8.
* Expose slaves of OVS bridges and ports.

The following changes were backported to 1.12.x releases between 1.12.0
and 1.12.2 are also present in NetworkManager-1.14:

* fix missing symbols in libnm ABI for settings.

=============================================
NetworkManager-1.12
Overview of changes since NetworkManager-1.10
=============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Improved support for configuration checkpoint, including support in libnm.
* Added capability to set IP Tunnel configuration flags.
* The systemd-resolved DNS plugins now supports MDNS.
* systemd-resolved and dnsmasq DNS plugins now honor the DNS priority setting.
* Wi-Fi devices now support FILS for speedier roaming support.
* Drop dependency on libnl3 library.
* Add support for "onlink" routes.
* More robust connectivity checking.
* Dropped the obsolete "ifnet" settings plugin,
* Try harder to generate reasonable human-readable names for devices even if
  the hwdb contains garbage.
* Add an "overview" option to hide default values in nmcli, resulting in more
  concise output.
* Reworked the inner workings of D-Bus interface for better resource efficiency.
* Add support for configuring nmcli coloring via terminal-colors.d(5).
* Added experimental support for Meson build system,
* Added initial IWD Wi-Fi daemon support.
* A non-hexadecimal DHCPv4 client-id is now properly passed to
  dhclient with the first byte (type) set to zero, as stated in the
  documentation. This represents a change in behavior since previous
  versions where the first character of the string was used as
  type. The internal client is not affected by the change.
* DNS setting rc-manager=file now always follows dangling symlinks
  instead of replacing /etc/resolv.conf with a plain file.
* Added wake_on_wlan connection setting to configure
  wake-on-wireless-lan (WoWLAN).
* The libnm-glib library, deprecated in favor of libnm since NetworkManager 1.0,
  is now not built by default. While it can still be enabled, the distributions
  should have a good plan for removing it if they need to keep shipping it at
  this point.
* nmcli now scans for Wi-Fi networks before displaying them, if the last scan
  was too long ago.
* Added the ipv6.dhcp-duid property to allow configuring the DHCPv6 DUID
* Extended ipv6.dhcp-client-id property to support DHCP client identifiers
  depending on the MAC address and the stable ID.
* Set NM_DISPATCHER_ACTION environment variable in dispatcher scripts.

The following features were backported to 1.10.x releases from 1.10.0 to
1.10.10 are also present in NetworkManager-1.12:

* Fix crash during reapply of connection settings
* Fix connectivity timeout handling (bgo #794464),
* Retry activating devices when the parent becomes managed (rh #1553595),
* Correctly set the rp_filter value (rh #1565529).
* A fix to ensure teamd is respawned after daemon restart (rh #1551958).
* Better handle DHCP expiry (bgo #783391).
* Fix configuration of IPv6 over master interfaces (rh #1575944).
* ovs: fix compilation issue of OVS plugin and various fixes.
* team: add support for team runner "random".
* core: cleanup activation of device (rh #1537160).
* dhcp: retry indefinitely to renew the lease (rh #1503587).
* core: fix blocking autoconnect for no-secrets (rh #794014).
* libnm: mark async results as cancelled (bgo #794088).
* Load jansson at runtime. This solves a clash with json-glib that caused
    a gnome-control-center crash, but also gets rid of a hard dependency.
* Correct nmcli exit values after receiving a signal.
* Fix libnm secret agent asynchronous initialization.
* Add a default route for a modem even if it didn't sent a gateway.
* Improve communication of DAD failures.
* Remember device default metrics across daemon restarts.
* Various bug fixes including possible crashes.
* Added support for 'onlink' IPv4 routes attribute.
* Wait longer for the carrier to come up after a MTU change.
* Implemented abstraction for team connections that exposes team
    configuration items as distinct properties.
* Added basic support for tc queueing disciplines and filters.
* Introduced an Update2() D-Bus method to update connection settings
  with more flexibility.
* Many bug fixes and improvements.

============================================
NetworkManager-1.10
Overview of changes since NetworkManager-1.8
============================================

This is a new stable release of NetworkManager.  Notable changes include:

* NetworkManager includes now basic Open vSwitch support, good enough
    to be capable of setting up simple Open vSwitch configurations.
* Added support for activating PPP connections on non-Ethernet
  interfaces.
* It is now possible to authenticate to a Wi-Fi network using WPS
    (Wi-Fi Protected Setup).
* Implemented support for Wi-Fi PMF (Protected Management Frames,
    802.11w), which can be configured via the wifi-sec.pmf property.
* Now the maximum rate of wireless access points supporting 802.11 is
    properly calculated and exposed on D-Bus.
* Background scanning is now disabled for non-WPA-Enterprise Wi-Fi
    networks.
* Added support for the Bluetooth NAP (Network Access Point) profile.
* Added support for disabling connectivity checking via the D-Bus
    interface.
* The internal DHCP client now understands the domain-search option.
* Bridge connections support the group-forward-mask property.
* NetworkManager can now configure multiple IPv6 default routes
    received through RA and each gets configured with the announced
    preference.
* It is possible to specify the routing table for each static route.
* Support specifying a explicit routing table for any non-static-route,
    including routes from DHCP, device-routes, IPv6 autoconf.
* Device are left configured when a user sets them as unmanaged by
    NetworkManager.
* New connection.auth-retry property to configure how often authentication
    is prompted before failing the configuration.
* The platform code that handles synchronization with kernel status
    via netlink has been reworked and is more efficient.
* Allowed the update of connections that have an associated ifcfg-rh
    routing rules file.
* Non-UTF8 properties are now escaped when they are exported on D-Bus.
* NetworkManager-wait-online.service now starts NetworkManager.service
    if needed.
* The MAC address for bond connections can be changed in nmtui.
* Fixed dependency problems when setting the MTU of VLAN and master
    devices.
* The systemd-resolved DNS plugin properly handles the DNS priority
    setting.
* Fixed setting a DHCP timeout greater than 60 seconds (dhclient).
* Fixed some memory leaks.
* Many other bug fixes and improvements.

============================================
NetworkManager-1.8
Overview of changes since NetworkManager-1.6
============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Default routes set by devices that failed connectivity checks are now
    penalized with a higher metric
* nmcli is now able to produce output more friendly for machine parsing
* The slaves available at the time a master connection is activated are
    enslaved in a stable order, making the automatic MAC address for Bonding
    devices more predictable.
* Hostname management is now more flexibly configured
* Support for additional route options (pref-src, src, tos, window, cwnd,
    initcwnd, initrwnd, mtu, lock-window, lock-cwnd, lock-initcwnd, lock-initrwnd,
    and lock-mtu).
* Fixed detection of EAP-FAST support in wpa_supplicant
* Support for handling PINs for PKCS#11 tokens as secrets
* GSM and CDMA connections now have a MTU property
* An option to disable selected TLS versions during EAP phase 1 authentication
* The 802.1x authentication timeout is now configurable to allow a faster
    fallback to other connections
* Persist managed state of device until reboot. This improves seamless take over
    of a previously managed device after restart of NetworkManager.
* Better handle devices that are externally managed by somebody else by
    consistently generating an in-memory connection to reflect the external
    state.
* Expose SRIOV capability of a device on D-Bus and support configuring the
    number of virtual functions via NetworkManager.conf.
* Support matching networking devices via new "driver:" device spec in
    NetworkManager.conf.
* Introduced support for creating and managing dummy links
* The teaming devices now support setting a hardcoded MAC address
* Settings of bonding devices can now be modified on-the-fly, without the
    need to reactivate a connection
* The failures to activate a connection now communicate better error
    responses to nmcli
* Dropped dependency on libgudev
* Reverse Path filtering is now disabled in multihoming configurations where
    it would interfere with legitimate network traffic
* libcurl is used instead of libsoup for connectivity checking, resulting in
    a smaller dependency footprint
* With DNS mode "rc-manager=symlink", don't write /etc/resolv.conf as
    a symlink if it already exists as a regular file.
* Support attaching user-data in form of key-value pairs to connection profiles.
* Fix accpeting fully qualified name for ipv4.dhcp-hostname setting.
* Make NetworkManager more forgiving to failure to change the MAC address during
    scanning.
* Many bug fixes and improvements

============================================
NetworkManager-1.6
Overview of changes since NetworkManager-1.4
============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Added support for managing the MACsec links. Requires support in
    wpa_supplicant (version newer than 2.6).
* Support for configuration and discovery of Web Proxy settings with
    PacRunner service.
* The ipv6.method=shared is now supported, utilizing DHCPv6 Prefix
    Delegation option to obtain prefixes for the interface.
* Support for systemd-resolved local DNS forwarder backend.
* The configuration is now read from /run/NetworkManager/conf.d as well.
    This is useful for handing over configuration discovered on system
    startup to NetworkManager.
* The PPP manager can now be split into a separate package.
* Added initial support for PKCS#11 tokens with 802.1x authentication.
* Introduced Vala bindings for libnm.
* NetworkManager would now keep most connections up on shutdown (except Wi-Fi
    connections, VPN connections and other kinds that can't be assumed on
    startup)
* The checkpoint/restore connection can now also remove new connections and
    disconnect devices that were activated since the checkpoint was taken.
* New connection.autoconnect_retries property that allows fine-tuning
    the autoconnect behavior.
* Fix emission of NM-style PropertiesChanged signals and deprecate them
    for PropertiesChanged on "org.freedesktop.DBus.Properties" interface.
* Change the meaning of unset "cloned-mac-address" settings from "permanent" to
    "preserve". This changes the default value and affects existing connections
    during upgrade that did not explicitly configure cloned-mac-address. This
    has the effect that externally configured MAC addresses are preserved
    by default instead of setting the permanent address (bgo#770611).
* Avoid reading the permanent MAC address before the device is initialized
    by UDEV. This avoids a race where NetworkManager might detect the MAC
    address of the wrong interface.
* The cloned.mac-address property can now be used with Bond and Bridge
    devices.
* The ifcfg parsing code has been reworked for better compatibility with
    actual shell variable files.
* nmtui now supports creating and editing IP tunnel connections.
* The libnm client library now uses the D-Bus ObjectManager API that allows
    for quicker initialization of the clients.
* nmtui now utilizes the asynchronous libnm client API to paralellize
    communication with the daemon, reducing the client startup time.
* Ethernet devices now use "802-3.speed" and "802-3.duplex" properties to
    allow controlling overriding the negotiated link parameters.
* Order in which IP addresses are configured is now preserved so that
    primary address is selected correctly.
* Details of the DNS information obtained from the connections is now
    exposed on the D-Bus and can be inspected with nmcli.
* Fixed race conditions when renaming interfaces, for example as done
    by UDEV for persistent interface naming. This could cause detecting
    devices as the wrong hardware type.
* Added the support for DHCPV6_HOSTNAME and DHCPV6_SEND_HOSTNAME keys in
    ifcfg files that control "dhcp-hostname" and "dhcp-send-hostname"
    properties of the "ipv6" setting.
* The stable-addressing for MAC address randomization and RFC7217 IPv6 stable
    privacy addressing can now be more flexibly configured using dynamic
    randomization seeds in "connection.stable-id".
    See "examples/nm-conf.d/30-anon.conf" for example use.
* When the master of Team, Bridge and Bond devices is specified as a connection
    UUID, the ifcfg-rh plugin now writes the master connection's interface name
    into the ifcfg file for improved compatibility with the legacy network service.
* Improve handling of MTU by resetting the previous MTU when the device deactivates
    and reset the MTU to a defined value on activation.
* Improve tracking of parent devices for dependent devices like ip-tunnels, MACVLAN,
    VETH, VLAN, and VXLAN.
* Many bug fixes and improvements

============================================
NetworkManager-1.4
Overview of changes since NetworkManager-1.2
============================================

This is a new stable release of NetworkManager.  Notable changes include:

* The MAC address assigned to a device can now be set according to
    different policies: preserve, permanent, random, stable
* NetworkManager now waits for IPv6 DAD to terminate before completing
    the activation
* Added support for setting IPv6 tokenized interface identifiers
    through the 'ipv6.token' connection property
* Added a 'Reload' D-Bus method to reload configuration and reapply
    DNS configuration
* Added ability to create a configuration checkpoints and rolling back
    changes after a timeout.
* NetworkManager now follows symlinks when accessing resolv.conf and
    rc-manager is set to 'file'
* Added support for oFono as modem manager
* The devices now exposes counters of transferred data
* The 'may-fail' property of ipv4 and ipv6 settings is now respected
    more accurately
* The timeout for requests of secrets to agents has been increased
    from 25 to 120 seconds
* Name servers passed to dnsmasq now specify an egress interface to
    avoid problems with multiple active connections
* Reverse DNS entries for IPv6 are now added to dnsmasq, and IPv4
    reverse entries now honor the network prefix
* A new 'dns-priority' property of ipv4 and ipv6 settings can be used
    to tweak the order of servers in resolv.conf when multiple
    connections are active
* configure script accepts --enable-{address,undefined}-sanitizer
    options to build NetworkManager with GCC sanitizers
* The default resolv.conf manager can now be specified at build time
    using the --with-config-dns-rc-manager-default configure option
* NetworkManager is now compiled with --gc-sections to reduce
    executable size
* Added a new 'VPN_PLUGIN' logging domain
* It is now possible to change the configuration currently applied on
    a device with 'nmcli device modify' and 'nmcli device reapply'
* nmcli invoked without parameters shows an overview of the current
    network configuration
* The 'nmcli connection add' syntax has been extended and is now
    possible to pass properties (e.g. 'ipv4.dns') along with aliases
* nmtui now returns to initial menu after a sub-form exits
* Improved bash autocompletion for nmcli
* Now devices are disconnected before the system suspends, executing
    dispatcher scripts.  This allows external applications to be notified
    of the change in connectivity
* Dispatcher scripts are now called also when connectivity status
    changes
* Many other fixes and improvements

============================================
NetworkManager-1.2
Overview of changes since NetworkManager-1.0
============================================

This is a new stable release of NetworkManager.  Notable changes include:

* MAC addresses during Wi-Fi access point scanning are now randomized
    if wpa_supplicant supports PreassocMacAddr.
* Added an option to enable random MAC addresses for association to Wi-Fi access
    point (defaults to disabled).  Controlled with 'wifi.mac-address-randomization'
    property (MAC_ADDRESS_RANDOMIZATION key in ifcfg files).  Requires support from
    wpa_supplicant.
* Wi-Fi scanning now utilizes wpa_supplicant's AP list.
* Added support for Wi-Fi powersave, configured with POWERSAVE key in ifcfg
    files.
* Added support for creation of more types of software devices: tun & tap,
    macvlan, vxlan and ip tunnels (ipip, gre, sit, ip6ip6 and ipip6).
* The software devices (bond, bridge, vlan, team, ...) can now be stacked
    arbitrarily.  The nmcli interface for creating master-slave relationships
    has been significantly improved by the use of 'master' argument to
    all link types.
* RFC7217 stable privacy addressing is now used by default to protect from
    address-based host tracking. The IPv6 addressing mode is configured with
    IPV6_ADDR_GEN_MODE key in ifcfg files.
* Improved route management code to avoid clashes between conflicting
    routes in multiple connections.
* Refactored platform code resulting in more robust interface to platform,
    less overhead and reduced memory footprint.
* Improved interoperability with other network management tools.  The
    externally created software devices are not managed until they're
    activated.
* The Device instances now exist for all software connections and the platform
    devices are now only created when the device is activated.  This makes it
    possible for connections with device of same name not to clash unless
    they're activated concurrently.  The links are now not unnecessarily present
    unless the connection is active, avoiding pollution of the link namespace.
* NetworkManager now correctly manages connectivity in namespace-based
    containers such as LXC and Docker.
* Support for configuring ethernet Wake-On-Lan has been added.
* Added LLDP listener functionality and related CLI client commands. Enabled via
    LLDP option in ifcfg files.
* CLI secret agent has been extended with support for VPN secrets.
* The command line client now utilizes colors for its output.
* The command line client now sorts the devices and properties for better
    clarity.
* Numerous improvements to Bash command completion for nmcli.
* NetworkManager relies on less external libraries.  The use of dbus-glib
    has been replaced with gio's native D-Bus support and libnl-route is no
    longer used.
* Dependency on avahi-autoipd has been dropped.  Native IPv4 link-local
    addressing configuration based on systemd network library is now used
    instead.
* Hostname is now managed via systemd-hostnamed on systemd-based systems.
* Management of resolv.conf can be changed at runtime, private resolv.conf
    is always written in /run.
* NetworkManager can now write DNS options to resolv.conf.
* Added an option to enable the old-fashioned /etc/resolv.conf handling
   (using a symlink)
* Updated version of systemd network library used for internal DHCP and
    IPv4 link-local support.
* Support for event logging via audit subsystem has been added.
* Support for native logging via systemd-journald has been added taking
    advantage of its structured logging.
* Live reconfiguration of IP configuration after changing the settings without
    reactivation of the device with "nmcli device reapply" command and via
    D-Bus API.
* The API for VPN plugins now supports multiple simultaneous connections.
    Most popular VPN plugins have been updated to support this functionality.
* The libnm library now provides API to access VPN service definitions.
* New DHCP_FQDN key in ifcfg files to configure the full FQDN to be sent to
    the DHCP servers.
* The timeout for DHCP requests can now be modified using the
    'ipv4.dhcp-timeout' property.
* Added multicast_snooping option to BRIDGING_OPTS ifcfg key.
* Added support for detecting duplicate IPv4 addresses, with a timeout
    configurable through the ipv4.dad-timeout connection property.
* Fixed a race condition that could potentially lead to unauthorized access
    to connection secrets (CVE-2016-0764).
* dnsmasq configuration for shared connections can now be extended by
    placing custom files in /etc/NetworkManager/dnsmasq-shared.d/.
* Generic devices are no longer assumed unless explicitly requested by
    user.
* The reorder-header VLAN flag setting is now honored; to keep backwards
    compatibility in behavior, an existing REORDER_HDR=0 ifcfg-rh key is
    ignored; the flag must be disabled with VLAN_FLAGS=NO_REORDER_HDR.
* NetworkManager now checks the connection data from client for validity
    and gracefully handles unknown properties in client. This improves
    interoperability between the server and clients of different versions.
* The activation of a VLAN device with a virtual parent that is inactive
    now results in a parent being activated first.
* The server name used with 802.1x authentication can now be constrained
    to a particular domain suffix (CVE-2006-7246).
* Fair amount of bugs was fixed and robustness was generally improved.

The following features were backported to 1.0.x releases from 1.0.0 to 1.0.10
are also present in NetworkManager-1.2:

* Added support for handling VPN secrets to nmtui and nmcli agent.
* The team devices can now properly be enslaved to bridges.
* Failed DHCP attempts for assumed connections are now retried after
    a timeout.
* Default wired connection is now created after udev registers the device.
* Support for Bluetooth DUN devices with Bluez 5 has been fixed.
* The 'ipv6.ignore-auto-dns' property is now properly honored making it
    possible to override automatically obtained name servers.
* Invalid permanent MAC addresses as reported by some devices are now
    ignored.
* Device links reported by more recent versions of Linux kernel that reside
    in different network namespaces are no longer confused with links in
    the namespace NetworkManager runs in.
* MAC address changes of bond or team devices are now properly propagated
    to VLANs created on the device.
* Fixed error handling for teaming devices with invalid configuration.
* Wi-Fi AP list is now updated correctly after AP mode has been used.
* The error handling for VPN secret agents is now significantly more robust.
* Detection of s390 CTC devices now works properly.
* A GATEWAY key in in /etc/sysconfig/network now no longer affects
    non-static connections.
* Added support for IPv6-only VPN connections.
* The systemd service now uses HUP signal to reload configuration.
* Change VLAN default flags to set REORDER_HDR for new connections.
* nmtui is now able to ignore automatically configured routes.
* Allow setting IPv6 and PPP settings for GDM and CDMA connections via
    nmcli.
* Added support for adding ADSL connections in nmcli.
* Improved capture portal detection.
* Default route through Wi-Fi connection is now preferred to Mobile
    Broadband if both are available.
* Expose a flag to determine whether a particular connection is metered
    via API and client tools. Configurable in ifcfg with CONNECTION_METERED
    key.
* Add support for locking connections to a channel within a particular
    band.
* Add support for configuring Wake-on-LAN capabilitites.
* Allow overriding the MTU for team device.
* The MTU setting from an IPv6 neighbor discovery Router Advertisements is
    now ignored if applying it would result in invalid configuration.
* Some configuration options can now be changed without restarting the
    daemon. Notably, this applies to 'dns', 'connectivity' and
    'ignore-carrier' settings.
* The connection activation was made more robust. If an active connection
    is reactivated, the device it is active on takes precedence. If an attempt
    is made to activate a connection on a different device than the one it is
    active on, the activation proceeds removing the connection from the active
    device.
* The device specifiers in configuration files now support negation via
    'except:' match.
* Devices that only have IPv6 link-local address are no longer assumed to
    be connected.
* nmcli now provides hints and tab-completion for enumeration properties.
* If the IPv6 interface tokens are set they are honored when creating an
    interface identifier for IPv6 addressing.
* NetworkManager now maintains correct routing configuration when multiple
    interfaces are connected to the same network.
* The management of devices can now be controlled with udev rules. The veth
    devices as well as the virtual Ethernet devices of various
    virtualization tools (VMWare, VirtualBox, Parallels Workstation) are
    now ignored by default.
* The IPv6 privacy extensions are now enabled by default and handling of
    the ip6-privacy sysctl has been improved.
* Activating a Bond, Bridge or Team device can now optionally activate the
    slave connections as well. The behavior is controlled with
    'connection.autoconnect-slaves' property and AUTOCONNECT-SLAVES key in
    ifcfg files.
* The platform support code has been refactored, resulting in better
    scalability in large configurations.
* Changes to network interfaces configuration done outside NetworkManager
    are now picked up and exposed to the user via NetworkManager API and tools.
* A connection can now optionally leave externally configured default route
    in place instead of overriding it. The behavior is controlled with
    'ipv4.never-default' and 'ipv6.never-default' properties.
* nmcli allows multiple devices for 'nmcli device disconnect/delete'.
* Firewall zone is added to firewalld for device-based VPN connections too.
* Wi-Fi devices now indicate support for 2GHz and 5GHz frequencies
* "nmcli device" output now indicates physical port ID
* New config items added to the 'ifcfg-rh' plugin:
  - IPV4_ROUTE_METRIC and IPV6_ROUTE_METRIC
  - DEVTIMEOUT
  - IPADDR and PREFIX are now supported for specifying address ranges of
      shared IPv4 connections
* Dispatcher scripts now get a CONNECTION_FILENAME variable with the path
    to the configuration file for the connection
* An example dispatcher script that is able to apply complex routing rules
    (such as setting up policy-based routing) for 'ifcfg-rh' connections was
    added to examples/dispatcher/.
* 'mode' key of Bond device options property now accepts numeric values
* Connection attempts for devices without carrier on startup now wait for
    carrier to appear within a short timeout instead of failing
    immediately. This makes system startup more robust.
* Bridge connectivity is now properly restored on resume from suspend
* The D-Bus name is acquired earlier during the daemon startup. This makes
    it possible for the systemd service manager to optimize the service
    startup so that services that require networking are activated sooner
    contributing to faster system start up time.
* A lot of memory leak problems were fixed, resulting in reduced memory usage.
    Many of them were discovered as a result of improvements in use of
    Valgrind in the testing infrastructure.
* Management of 'teamd' daemon instances for Team devices is now more robust.
* The 'dnsmasq' daemon respawns when it terminates and it is configured for
    management of DNS resolver configuration
* Hostnames that are not fully qualified are no longer sent to a DHCPv6
    server for a dynamic DNS update
* Connection UUIDs are now checked for uniqueness when connection
    configurations are read
* Receipt of a NDP Router Advertisement can no longer lower the IPv6 hop
    limit (CVE-2015-2924)

===============================================
NetworkManager-1.0
Overview of changes since NetworkManager-0.9.10
===============================================

This is a new stable release of NetworkManager.  Notable changes include:

* A new 'libnm' GObject-based client library to replace libnm-util/libnm-glib
  - IP address, IP route, hardware address, and other properties are now
      represented as strings
  - Based on GIO's GDBus bindings instead of dbus-glib
  - Uses modern GObject APIs including GAsyncResult and GVariant
  - For more information see https://wiki.gnome.org/Projects/NetworkManager/libnm
* Devices and VPN connections now have individual default routes.  Priorities
    are handled through configurable route metrics.
* nmcli now supports password requests and PolicyKit authorizations
* A faster, lighter-weight (though less capable) internal DHCP client has been
    added and may be selected with the "dhcp=internal" option.  It supports
    fewer DHCP options and does not yet support DHCPv6.
* A new 'configure-and-quit=yes' option has been added for environments with
    less dynamic network configuration
* When running on 3.17 and later kernels, NetworkManager handles IPv6LL address
    assignment to ensure that IPv6 connectivity is not enabled until
    intentionally configured by the user
* NetworkManager no longer causes the nl80211 kernel module to be loaded on
    systems with no Wi-Fi devices
* Bluetooth DUN support now works with Bluez 5.x
* VPN connections can now persist across link changes and suspend/resume if
    their VPN plugin supports this feature
* A new 'ibft' settings plugin has been added to support firmware-based
    iBFT/iSCSI configurations.  This functionality has been moved to 'ibft'
    from the 'ifcfg-rh' plugin.
* IPv6 router advertisement MTUs are now respected
* NetworkManager no longer requires polkit libraries at runtime when Polkit
    support is enabled, and Polkit can be disabled at build time too
* Automatically created connections are now deleted when their device goes away
* 'nmcli dev connect' now attempts to create a connection if none exists
* Manually configured static IPv6 configuration is kept even if SLAAC fails
* Manpages for the 'keyfile' and 'ifcfg-rh' plugins now describe their
    configuration syntax and available options
* WWAN connections now support IPv6 if the modem and provider support IPv6
* Software devices (bridge, bond, team, etc) can now be deleted from the D-Bus
    API or with nmcli
* The manpages, documentation, and API annotations have received many cleanups
* Externally created virtual interfaces are no longer managed by NetworkManager
    until they are set "up" or activated via nmcli
* Team device support is now an optional plugin


==============================================
NetworkManager-0.9.10
Overview of changes since NetworkManager-0.9.8
==============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Added a new curses-based client called "nmtui" for easier console operation
* Added interactive connection editing and creation mode to nmcli with detailed
    help and tab completion support
* nmcli bash completion has been greatly improved
* Added support for Data Center Bridging (DCB) and FibreChannel over Ethernet (FCoE)
* IPv6 autoconfiguration is now done in userspace with libndp instead of the kernel
* The D-Bus daemon is no longer required for root-only operation
* Wi-Fi, ADSL, WWAN, and Bluetooth are now optional plugins, reducing install size
* Added support for Infiniband Partitions
* Network connection files are no longer watched by default, use "nmcli con reload"
    to notice changes made externally or set "monitor-connection-files=true" in
    NetworkManager.conf's [main] section
* Connections can now be locked to interface names in addition to hardware/MAC addresses
* A new "ignore-carrier" configuration option is available to ignore the carrier
    on selected interfaces
* A new "dns=none" option has been added to suppress changes to /etc/resolv.conf
* Changes made to IP addresses, IP routes, and master/slave relationships from
    external tools are now recognized and reflected in the D-Bus API
* Assuming the existing configuration of interfaces without changing that
    configuration is now more reliable
* The 'root' user is no longer subject to PolicyKit access controls and usage
    of D-Bus "at_console" permissions has been removed
* Configuration file snippets can be dropped in /etc/NetworkManager/conf.d to
    change smaller sets of configuration options
* Added IP-level support for more software/virtual interfaces types including
    GRE, macvlan, macvtap, tun, tap, veth, and vxlan interfaces
* All network interfaces known to the kernel are now exposed through
    the D-Bus interface
* Improved support for routing-only VPNs like openswan/libreswan/strongswan
* Added support for "temporary" connections which are not saved to disk until
    requested
* Added WWAN autoconnect support and fixed issues with airplane mode handling
* NetworkManager-wait-online systemd service behavior is more reliable
* The dispatcher timeout has increased to 10 minutes, and new "pre-up" and
    "pre-down" events have been added which block activation until complete
* NetworkManager no longer prevents Wake-on-LAN functionality from working
* PPPoE now requires userland "rp-pppoe" to work around kernel bugs
    that prevent detecting server-side termination of the PPP link
* An ARP announcement is now sent after IPv4 addresses are configured
* Added a DNS plugin for dnssec-trigger for better DNSSEC operation
* More properties are now exposed via the D-Bus properties interface in
    addition to getter/setter functions
* Added support for custom IP address ranges for Shared connections
* Fatal connection failures now block automatic reconnection more reliably
* VPN connection IP details are now available via the D-Bus interface
* VPN plugins can now request additional/new secrets from the user during the
    connection process


==============================================
NetworkManager-0.9.8
Overview of changes since NetworkManager-0.9.6
==============================================

This is a new stable release of NetworkManager.  Notable changes include:

* New AvailableConnections property for Device objects
* Better handling of various rfkill/Airplane Mode switches
* Fixed handling of DNS servers for some mobile broadband devices
* Don't duplicate various IPv6 routes added by the kernel
* Ensure buggy ethernet driver carrier indications are handled correctly
* Fix crash in dnsmasq plugin when no nameservers were present
* Add support for 4G LTE network modes
* Fix signal handling when daemonizing at startup
* Don't autoconnect to Wi-Fi networks that have never successfully connected
* Only request new Wi-Fi secrets during the initial association or when the
    secrets are known to be wrong, not every time the connection randomly fails
* Add capability to autoconnect VPN connections when a parent connection succeeds
* Add configure-time option for "permissive" system connection editing policy
* Various libnm-glib fixes for asynchronous usage
* Fix gateway handling when given with secondary IP addresses
* Optionally listen to systemd for suspend/resume events instead of UPower
* Fix 'seen-bssids' property when retrieving Wi-Fi connections via D-Bus
* Add support for AP-mode Wi-Fi hotspots (instead of just Ad-Hoc)
* Add a "slaves" property to Bond devices
* Add support for ModemManager 0.7/0.8
* Allow more human-readable formatting of IP address in keyfile connections
* Drop support for dhclient v3
* Move PPP support to a separate plugin, so that it can be packaged separately
    and reduce the dependency on the core package.
* Add support for DHCPv6 server-side Dynamic DNS
* Add support for bridge master devices and bridge ports
* Fix canceling secrets requests in GUI agents
* Always enable Proactive Key Caching (PKC, also called OKC) for WPA Enterprise
    Wi-Fi configurations


==============================================
NetworkManager-0.9.6
Overview of changes since NetworkManager-0.9.4
==============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Many libnm-glib fixes, including crashes when NetworkManager restarts
* Enhanced IPv6 stability and compatibility
* Fix regression in carrier handling for devices that don't support carrier detect
* Add ability to connect to new Wi-Fi networks from nmcli
* Add native support for ADSL modems using PPPoE or PPPoATM
* Reduce number of changes made to DNS information during connection setup
* Add support for IPv6-enabled VPN connections
* Add device driver version, firmware version, and autoconnect properties to D-Bus API
* Add on-demand Wi-Fi scan support
* Fix IPv6 default gateway handling for DHCPv6
* Add Vala language bindings
* Fix various crashes and issues in the ifcfg-rh system settings plugin
* Fix race with multiple interfaces running DHCP at the same time
* Add Linux From Scratch (LFS) support
* Allow customized dnsmasq local caching nameserver config via /etc/NetworkManager/dnsmasq.d/
* Fixes for VLAN and bonding when libnl2 or earlier are used
* D-Bus API, libnm-glib, libnm-util, and GObject Introspection documentation updates


==============================================
NetworkManager-0.9.4
Overview of changes since NetworkManager-0.9.2
==============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Better handling of Wi-Fi devices via nl80211 when available (instead of WEXT)
* IP configuration is now non-blocking; waiting for IPv6 RA no longer blocks
    the device from activating if IPv4 is ready and vice versa
* Added support for firewall "zones" via FirewallD
* Added basic support for bonded interfaces
* Wi-Fi connections are no longer locked to a specific MAC address if they are
    "locally administered" addresses (ie, 02:::::)
* New state change reasons have been added for mobile broadband PIN errors
* Agent-owned secrets are now sent to agents for newly created connections
* Support for non-UTF8-encoded 802.1x passwords has been added
* libnm-glib now fetches some properties more aggressively (like active
    connections, access points, etc)
* Added basic support for IP-over-Infiniband interfaces
* Added support for device plugins and converted WiMAX support to a plugin for
    easier packaging and simpler dependencies
* Added support for VLAN interfaces
* Added support for 802.1x EAP-FAST authentication
* Added non-blocking mode and API to libnm-glib
* Linux Wireless Extensions (WEXT) support can be disabled at configure time
    with --with-wext=no
* IPv6 Privacy Extensions are now enabled by default for new connections
* Support for checking Internet connectivity has been added
* The ifnet system config plugin rewrites config files less often
* A bug causing IPv6 address assignment to fail on newer kernels with libnl3
    has been fixed
* Fix a bug in the ifcfg-rh plugin with backticks in WPA passphrases
* Ensure connections that cannot be stored are ignored by the ifnet plugin
* Enable out-of-the-box IPv6 connectivity by allowing IPv4 to fail if IPv6 succeeds
* Allow proxying of DNSSEC data when using the dnsmasq local caching nameserver plugin
* Add support for multiple domain names sent from VPN plugins
* Removed support for Wi-Fi Ad-Hoc WPA connections due to kernel bugs


==============================================
NetworkManager-0.9.2
Overview of changes since NetworkManager-0.9.0
==============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Support for libnl2 and libnl3 and various memory leak fixes
* Bug fixes for the ifnet config plugin
* Ensure IPv6 link-local DNS servers work correctly in the dnsmasq DNS plugin
* Add ability for nmcli to delete connections
* Fix setup of connection sharing with newer iptables versions
* Ensure WiMAX activation emits correct signals (fixes initial signal strength)
* Fix an issue with duplicated keyfile connections
* Ensure the 'novj' options is passed through to pppd
* Store timestamps for VPN connections too
* Fix a crash when deleting default wired connections
* Fix a security issue in the ifcfg-rh plugin with newlines in file names
* Fix the "SpecificObject" property for active VPN connection objects
* Improve handling of rfkill on some platforms
* Spaces no longer used in ifcfg config file names
* IPv6 RAs are now accepted when forwarding is configured
* dnsmasq local caching nameserver plugin cache size bumped to 400 entries (from 150)
* Fix handling of SSIDs in the keyfile plugin
* Fix some GObject Introspection annotations in libnm-glib and libnm-util
* Fix setting hostnames from DHCP
* Fixes for building with recent GLib versions
* Don't update routing and DNS until a device is managed
* Fix bug causing IPv6 RA-provided routes to be ignored
* Fix possible wrong handling of 'keyfile' connection certificates
* Correct Shared connection IP address range to be as documented


==============================================
NetworkManager-0.9.0
Overview of changes since NetworkManager-0.8.x
==============================================

This is a new stable release of NetworkManager.  Notable changes include:

* All connections and configuration now managed by NetworkManager
* Secrets for any connection can now be stored in user session or by NetworkManager
* All secrets can now be requested each time
* Fast User Switching support
* Support for WiMAX mobile broadband
* Connections can now be restricted to one or more users
* Support for 802.1X certificate subject matching for greater security
* Requires wpa_supplicant 0.7 or later
* Better support for AP roaming using nl80211 and background scanning
* Simplified D-Bus API for easier client usage
* Support for GObject Introspection in libnm-glib and libnm-util


==============================================
NetworkManager-0.8.6
Overview of changes since NetworkManager-0.8.4
==============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Fix handling of WINS server address in libnm-glib
* Fix checks for s390 CTC device types
* Fix export of nm_device_get_ip_iface() in libnm-glib
* Fix export of IPv6 DNS GValue conversion functions in libnm-glib
* Recognize and manage platform 'gadget' devices
* Send only "short" hostname, not FQDN, to DHCP servers
* Allow "_" as a valid character for GSM APNs
* Handle shared connections in the ifnet plugin
* Fix Ad-Hoc frequency selection for user-created Ad-Hoc networks
* Allow failed connections to be retried when Ethernet carrier bounces
* Allow usage of paths for certificates and keys in the keyfile plugin
* Fix crash requesting system VPN secrets
* Add ability to blacklist certain MAC addresses for wired & wifi connections
* Ensure users are authorized to share wifi networks (CVE-2011-2176)


==============================================
NetworkManager-0.8.4
Overview of changes since NetworkManager-0.8.2
==============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Preliminary support for Exherbo Linux
* Logging fixes to suppress unnecessary messages
* Ensure removed devices are cleaned up
* Fix potential 64-bit crash updating timestamps
* IPv6 setup, routing, and compliance fixes
* Fix WWAN enable/disable handling
* Handle reverse DNS lookups with local caching nameserver configurations
* Ensure usable DNS configuration is written when NetworkManager quits
* No longer updates /etc/hosts when hostname changes
* Request WPAD option from DHCP servers
* Allow use of paths for certificates and keys in connection keyfiles
* Allow operation without any DHCP client installed
* Fix operation with newer versions of dnsmasq
* nmcli support for WWAN connections
* Persistent hostname sent to DHCP servers by default
* Allow disabing PPP support at build time
* Red Hat/Fedora ifcfg plugin fixes for handling S390 CTC device configuration
* Red Hat/Fedora ifcfg plugin fixes for handling IPADDR config items
* Shutdown crash fixes
* Memory leak fixes
* Documentation fixes and updates
* and much more...

==============================================
NetworkManager-0.8.2
Overview of changes since NetworkManager-0.8.1
==============================================

This is a new stable release of NetworkManager.  Notable changes include:

* Native local caching nameserver support using dnsmasq
* Automatically detect addition and removal of new VPN plugins
* Support for handling suspend/resume signals from UPower
* Ensure users are allowed to enable/disable Wi-Fi and networking
* Ensure Wi-Fi enable state is perserved across reboot and suspend
* Better handling of /etc/hosts and preservation of custom hostnames
* Support for the systemd session management service
* Better handling of 'keyfile' system connection errors
* Support for S390 network devices
* and much more...


==============================================
NetworkManager-0.7.0
Overview of changes since NetworkManager-0.6.6
==============================================

This is a new major stable release of NetworkManager.  Notable changes include:

* Multiple active devices
* Internet connection sharing
* Support for many mobile broadband devices
* Full static IP support
* More reliable connections
* Rich, flexible D-Bus API
* Boot-time connections (no logins required)


==============================================
NetworkManager-0.6.2
Overview of changes since NetworkManager-0.6.2
==============================================

0.6.2 is a bug fix release.  Note that NetworkManager no longer automatically
runs dhcdbd if it is not running.  This means that it is now the system's
responsibility to start dhcdbd prior to NetworkManager, e.g. in the
distribution's NetworkManager initscript.

* NetworkManager
	* Many, many bug fixes (Everyone)
	* Dynamic WEP Support (Robert Love)

* nm-applet
	* Many bug fixes (Everyone)


==============================================
NetworkManager-0.6.1
Overview of changes since NetworkManager-0.6.0
==============================================

0.6.1 is a minor bug fix release.

* NetworkManager
	* Improved activation cancelation (Dan Williams)
	* Workarounds for non-WPA drivers (Dan Williams)
	* Fix WPA Enterprise crasher (Robert Love)

* nm-applet
	* Hide password entry fields by default (Robert Love)
	* Add toggle to show/hide password field (Robert Love)
	* Add 'Remove' option to right-click menu (Robert Love)

==============================================
NetworkManager-0.6.0
Overview of changes since NetworkManager-0.5.1
==============================================

This releases ushers in WPA support, as well as many other features, bug fixes,
and clean ups.

We now require libnl, a netlink library (http://people.suug.ch/~tgr/libnl/) and
wpa_supplicant, a WPA supplicant (http://hostap.epitest.fi/wpa_supplicant/).

Two new VPN modules are part of the distribution: openvpn and pptp.

* NetworkManager
	* WPA and WPA2 support (Dan Williams)
	* WPA Enterprise support (Robert Love)
	* Rearchitecting, refactoring (Dan Williams)
	* wpa_supplicant support (Dan Williams, Kay Sievers)
	* NIS support (Robert Love)
	* DHCP hostname support (Timo Hoenig)
	* ISDN support, improve dial up support (Robert Love)
	* Man pages (Robert Love)
	* Survive DBUS and HAL restarts (Timo Hoening)
	* Generate PID files (Dan Willians)
	* Bug fixes and clean ups (the whole gang)

* nm-applet
	* New tray icon look and behavior (Robert Love, Dan Williams)
	* New wireless security layer (Dan Williams)
	* New "Enable Networking" toggle (Robert Love)
	* Display speed of current connection (Robert Love)
	* Bug fixes and clean ups (the whole gang)

==============================================
NetworkManager-0.5.1
Overview of changes since NetworkManager-0.5.0
==============================================

* NetworkManager
	* Don't drop the last scanned AP (Dan Williams)
	* Broadcast state change when disconnected (Robert Love)
	* The Slackware backend now builds (Nico)
	* Don't install unused config files (Dan Williams)
	* Add a test for libnm_glib_unregister_callback (Christopher Aillon)
	* Requires wireless-tools 28pre9 (Christopher Aillon)

* nm-applet
	* Use g_get_host_name () if we've got it (Christopher Aillon)
	* Fix an uninitialized variable (Robert Love)
	* Fix sensitivity of VPN items (Robert Love)


==============================================
NetworkManager-0.5.0
Overview of changes since NetworkManager-0.4.1
==============================================

* NetworkManager
   * Initscripts are now generated
   * Not waiting as long for scans to complete (Bill Moss).
   * Fix several D-BUS object leaks (John Palmieri, Dan Williams,
                                     Christopher Aillon)
   * VPN now advertises state changes
   * Make --without-named work (j@bootlab.org)
   * Make --with-dhcdbd work correctly (j@bootlab.org)
   * Fix timeout scan values (Bill Moss)
   * Send notifications of device strength changing so clients do
     not have to poll.
   * Don't return a UDI device if it doesn't exist (Tomislav Vujec)
   * Strip whitespace from the VPN banner (Bill Moss)
   * VPN Manager rewritten to better support signals (Dan Williams)
   * Don't allow clients to determine what states we should be
     scanning in, add logic to scan when we need to.
   * Blacklist some common ESSIDs such that multiple access points
     with these ESSIDs aren't treated as the same network.
   * Support for D-BUS enabled named (Dan Williams)
   * Only '#' is a valid comment in resolv.conf (Robert Love)
   * Don't try to set auth mode on the AP from the allowed list if
     it's NULL (Bill Moss)
   * Add internal scanning code so we don't have to use iwlib's
     code any longer (Dan Williams)
   * libnm now uses guints instead of gints for its callback IDs.
   * libnm_glib_unregister_callback () now works.
   * Fix our scanning interval (Robert Love)
   * Updates to backends for Gentoo, SuSE, RedHat, Debian, and
     Slackware (Robert Love, Peter Jones, Bill Nottingham,
                j@bootlab.org)
       - Dialup support in RedHat backend
       - ISDN support in SUSE backend
       - Other fixes

* nm-applet
   * The applet is no longer threaded (Dan Williams)
   * Dialogs no longer block the UI when shown
   * Passphrase dialog now treats Esc keypresses properly
   * Create Network and Connect to Network dialogs now have
     different window titles
   * New icons for connecting to a network and to a VPN
     (Diana Fong)
   * Context menu items have been cleaned up
   * Pressing enter in the passphrase entry should activate the
     default action.
   * Fix icon animation smoothness
   * Display more data in the Connection Information dialog
     (Robert Love).


============================================
NetworkManager-0.3.1
Overview of changes since NetworkManager-0.3
============================================

NetworkManager:

 * Debian backend fixes, Thom May
 * Build fixes, Thom May
 * Better handling of encrypted devices, Dan Williams
 * Better handling of user-selected access points, Dan Williams

NetworkManagerNotification:

 * Simplified D-Bus code, Dan Williams
 * Better error handling and feedback, Dan Williams
 * Greatly simplify the locking to UI smoother, Dan Williams

============================================
NetworkManager-0.3.0
Overview of changes since NetworkManager-0.2
============================================

NetworkManager:

 * Lots of fixes, Dan Williams
 * Support static IP addresses, Dan Williams
    - Get broadcast address from config files, Robert Paskowitz
 * Support for non-ESSID-broadcasting base stations, Dan Williams
 * Only accept and manager 802.3 and 802.11 devices, Dan Williams
 * Don't blow away an active wired connection on startup, Dan Williams
 * Improve strength calculation, Dan Williams
 * Constantly scanning behavior, Dan Williams
 * add .pc file, Colin Walters
 * move to syslog, Dan Willemsen
 * Improve MD5 hashing of 128-bit passphrases, Colin Walters
 * DBUS API docs, Dan Williams
 * Cleanups, Colin Walters
 * Trusted networks, Dan Williams
 * New Backends:
   - Debian, Thom May and Mark Roach
   - Slackware, Narayan Newton
 * Fixes and functionality improvements in Gentoo backend, Robert Paskowitz

Python:

 * Example python code, Bryan Clark.
 * python test framework, Bryan Clark

NetworkManagerInfo:

 * Trusted networks, Dan Williams
 * Escape ESSIDs in gconf, Dan Williams
 * Lifecycle improvements, John Palmieri

Translations:

 * New/Improved translations: da de sv en_CA nb no pa bs pt_BR wa gu es
   - Thanks to:
       Kjartan Maraas
       Christian Rose
       Adam Weinberger
       Amanpreet Singh Alam
       Akagic Amila
       Raphael Higino
       Pablo Saratxaga
       Ankit Patel
       Francisco Javier F. Serrador
       Martin Willemoes Hansen
       Hendrik Brandt

NetworkManagerNotification:

 * Complete rewrite, Jonathan Blandford and John Palmieri
   - Now a Notification area
   - Simpler menu
   - Hook up the "other network" dialog to do something
 * New icons, Diana Fong
